<?php
if (!function_exists("tail_file")) {
/* tail_file - Emulates the tail function with PHP native functions.
	  It is used in 0.8.6 to speed the viewing of the Cacti log file, which
	  can be problematic in the 0.8.6 branch.

	@arg $file_name - (char constant) the name of the file to tail
		 $line_cnt  - (int constant)  the number of lines to count
	     $line_size - (int constant)  the average line size to use estimate bytes
									  to seek up from EOF.  Defaults to 256 bytes */
function tail_file($file_name, $number_of_lines, $line_size = 256) {
	$file_array = array();

	if (file_exists($file_name)) {
		if ($number_of_lines > 0) {
			$fp = fopen($file_name, "r");

			/* reset back the number of bytes */
			$total_bytes = fseek($fp, -($number_of_lines * $line_size), SEEK_END);

			/* load up the lines into an array */
			$i = 0;
			while (1) {
				$line = fgets($fp);

				if (feof($fp)) {
					break;
				}else{
					$file_array[$i] = $line;
					$i++;
				}
			}

			if ($i > $number_of_lines) {
				$file_array = array_reverse($file_array);

				$i = 0;
				foreach($file_array as $line) {
					$new_file_array[$i] = $line;
					$i++;

					if ($i >= $number_of_lines) break;
				}

				$file_array = array_reverse($new_file_array);
			}

			fclose($fp);
        }else{
			$file_array = file($file_name);
		}
	}else{
		touch($file_name);
	}

	return $file_array;
}
}


?>